function [F, V] = cuboid(dims)
%% CUBOID Create faces and vertices of a cubid
%
% [F, V] = CUBOID(DIMS) creates faces and vertices of triangulation of a cuboid
% with dimensions DIMS = [ W , D , H ].
%
% Inputs:
%
%   DIMS                    1x3 array of cuboid dimensions as [ W , D , H ].
%
% Outputs:
%
%   F                       12x3 array of triangulated cubid faces.
% 
%   V                       8x3 array of triangulated cuboid vertices.
%
% Authors:
%   Philipp Tempel <philipp.tempel@ls2n.fr>



%% Parse arguments

% CUBOID(DIMS)
narginchk(1, 1)

% [F, V] = CUBOID(___)
nargoutchk(2, 2);



%% Algorithm

w = dims(1);
d = dims(2);
h = dims(3);

V = [ ...
  +w / 2 , -d / 2 , -h / 2 ; ...
  +w / 2 , +d / 2 , -h / 2 ; ...
  -w / 2 , +d / 2 , -h / 2 ; ...
  -w / 2 , -d / 2 , -h / 2 ; ...
  +w / 2 , -d / 2 , +h / 2 ; ...
  +w / 2 , +d / 2 , +h / 2 ; ...
  -w / 2 , +d / 2 , +h / 2 ; ...
  -w / 2 , -d / 2 , +h / 2 ; ...
];

F = [ ...
  1 , 2 , 6 ; ...
  1 , 6 , 5 ; ...
  2 , 3 , 7 ; ...
  2 , 7 , 6 ; ...
  3 , 4 , 8 ; ...
  3 , 8 , 7 ; ...
  4 , 1 , 5 ; ...
  4 , 5 , 8 ; ...
  5 , 6 , 7 ; ...
  5 , 7 , 8 ; ...
  1 , 4 , 2 ; ...
  2 , 4 , 3 ; ...
];

F = F(:,[1,3,2]);


end

%------------- END OF CODE --------------
% Please send suggestions for improvement of this file to the original author as
% can be found in the header. Your contribution towards improving this function
% will be acknowledged in the "Changelog" section of the header.
